### =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, playerlib, gamethread, usermsg, random
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func   = es.import_addon('sam/functions')
core   = es.import_addon('sam/core')
admins = es.import_addon('sam/core/admins')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
sort   = ('Kick','Ban','Unban','Manage Teams','Mute','Slay','Slap','Respawn','Blind',
		  'Freeze','Jetpack','Rave','Firework','Noclip','Godmode','Weapon Strip','Health','Cash')
TOGGLE = ('Freeze','Jetpack','Rave','Noclip','Blind','Godmode')
LOADS  = ('ban','mute','manageteams')
CACHE  = {}
DATA   = {}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# LOAD FUNCTIONS
	for x in LOADS: es.load('sam/core/pcontrol/%s' % x)

	# SET PLAYERS STATES
	for x in es.getUseridList(): remove(x)

	# CMDS
	func.SayCMD('!kick', kickCMD)
	func.SayCMD('!sam_kick', kickCMD)
	func.SayCMD('!slay', slayCMD)
	func.SayCMD('!sam_slay', slayCMD)
	func.SayCMD('!firework', fireworkCMD)
	func.SayCMD('!sam_firework', fireworkCMD)
	func.SayCMD('!noclip', noclipCMD)
	func.SayCMD('!sam_noclip', noclipCMD)
	func.SayCMD('!jetpack', jetpackCMD)
	func.SayCMD('!sam_jetpack', jetpackCMD)
	func.SayCMD('!blind', blindCMD)
	func.SayCMD('!sam_blind', blindCMD)
	func.SayCMD('!godmode', godmodeCMD)
	func.SayCMD('!sam_godmode', godmodeCMD)
	func.SayCMD('!freeze', freezeCMD)
	func.SayCMD('!sam_freeze', freezeCMD)
	func.SayCMD('!rave', raveCMD)
	func.SayCMD('!sam_rave', raveCMD)
	func.SayCMD('!respawn', respawnCMD)
	func.SayCMD('!sam_respawn', respawnCMD)
	func.SayCMD('!strip', stripCMD)
	func.SayCMD('!sam_strip', stripCMD)
	func.SayCMD('!slap', slapCMD)
	func.SayCMD('!sam_slap', slapCMD)
	func.SayCMD('!health', healthCMD)
	func.SayCMD('!sam_health', healthCMD)
	func.SayCMD('!cash', cashCMD)
	func.SayCMD('!sam_cash', cashCMD)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMDS
	func.unSayCMD('!kick')
	func.unSayCMD('!sam_kick')
	func.unSayCMD('!slay')
	func.unSayCMD('!sam_slay')
	func.unSayCMD('!firework')
	func.unSayCMD('!sam_firework')
	func.unSayCMD('!noclip')
	func.unSayCMD('!sam_noclip')
	func.unSayCMD('!jetpack')
	func.unSayCMD('!sam_jetpack')
	func.unSayCMD('!blind')
	func.unSayCMD('!sam_blind')
	func.unSayCMD('!godmode')
	func.unSayCMD('!sam_godmode')
	func.unSayCMD('!freeze')
	func.unSayCMD('!sam_freeze')
	func.unSayCMD('!rave')
	func.unSayCMD('!sam_rave')
	func.unSayCMD('!respawn')
	func.unSayCMD('!sam_respawn')
	func.unSayCMD('!strip')
	func.unSayCMD('!sam_strip')
	func.unSayCMD('!slap')
	func.unSayCMD('!sam_slap')
	func.unSayCMD('!health')
	func.unSayCMD('!sam_health')
	func.unSayCMD('!cash')
	func.unSayCMD('!sam_cash')

	# TAKE EFFECTS FROM PLAYERS BEFORE UNLOAD
	for x in [x for x in playerlib.getPlayerList('#alive') if notDead(x)]:
		unfreeze(x, False)
		unnoclip(x, False)
		unrave(x, False)
		unjetpack(x, False)
		unblind(x, False)
		ungod(x, False)

	# UNLOAD FUNCTIONS
	for x in LOADS: es.unload('sam/core/pcontrol/%s' % x)

	# POPUPS
	func.popupDelete('PCONTROL_MAIN')
	func.popupDelete('PCONTROL_LIST_PLAYERS')
	func.popupDelete('PCONTROL_HEALTH')
	func.popupDelete('PCONTROL_CASH')
	func.popupDelete('PCONTROL_DAMAGE')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID, SEND=True):
	popup = func.easymenu(('PCONTROL_MAIN', main_SELECT),'HOME')
	popup.settitle(func.header(func.langCommon('TITLE_PCONTROL')))
	for x in sort: popup.addoption(x, x)
	if SEND: popup.send(ID)

# ------------------------------------------------------------------------------- #
def main_SELECT(ID, OPTION, POPUP=None, PAGE=False, SEND=True):
	if admins.can(ID,OPTION):
		if not OPTION in ('Ban','Unban','Manage Teams','Mute'):
			if OPTION == 'Kick': l = playerlib.getPlayerList('#all')
			elif OPTION == 'Respawn': l = playerlib.getPlayerList('#t')+playerlib.getPlayerList('#ct')
			else: l = [x for x in playerlib.getPlayerList('#alive') if notDead(x)]
			if len(l):
				CACHE[ID] = OPTION.upper()
				popup = func.easymenu(('PCONTROL_LIST_PLAYERS', players_list_SELECT),'PCONTROL_MAIN')
				popup.settitle(func.header(func.langPcontrol(OPTION.replace(' ','_').upper())))
				for x in l:
					if admins.isAdmin(x.steamid):
						if admins.db['admins'][x.steamid]['Super Admin']: popup.addoption(x, '%s (Super Admin)' % x.name)
						else: popup.addoption(x, '%s (Admin)' % x.name)
					else: popup.addoption(x, x.name)
				if PAGE in l: popup.sendPage(func.sendPage(l.index(PAGE)))
				else: popup.send(ID)
				SEND = False
			else: func.hudhint(ID, func.langCommon('NO_PLAYERS_TOLIST'), func.errortag)
		else:
			m = es.import_addon('sam/core/pcontrol/%s' % OPTION.replace(' ','').replace('Un','').lower())
			if OPTION == 'Ban': m.banPage(ID)
			elif OPTION == 'Unban': m.unbanPage(ID)
			else: m.page(ID)
			SEND = False
	if SEND: page(ID)

# ------------------------------------------------------------------------------- #
def players_list_SELECT(ID, TARGET, POPUP=None, SEND=True, MSG=True):
	if admins.immunity(playerlib.getPlayer(ID),TARGET) or not ID:
		if ID: x = CACHE[ID].upper()
		if   x == 'KICK': kick(TARGET, False, MSG)
		elif x == 'SLAP':
			slap_damage(ID, TARGET, None)
			SEND = False
		elif x == 'HEALTH':
			health_amount(ID, TARGET)
			SEND = False
		elif x == 'CASH':
			cash_amount(ID, TARGET)
			SEND = False
		else:
			if notDead(TARGET) or x == 'RESPAWN':
				if   x == 'RESPAWN':
					if TARGET.team != 1: respawn(TARGET, MSG)
					elif MSG: func.hudhint(ID, func.langPcontrol('TARGET_SPEC'), '#greenRESPAWN')
				elif x == 'SLAY': slay(TARGET, MSG)
				elif x == 'FIREWORK': firework(TARGET, MSG)
				elif x == 'WEAPON STRIP':
					TARGET = playerlib.getPlayer(TARGET)
					if TARGET.weapon != 'weapon_knife': strip(TARGET, MSG)
					else: func.hudhint(ID, func.langPcontrol('CANT_STRIP_KNIFE'), '#greenWEAPON STRIP')
				elif x == 'FREEZE':
					if DATA[TARGET.userid]['Freeze']:
						unfreeze(TARGET, MSG)
						DATA[TARGET.userid]['Freeze'] = False
					else:
						freeze(TARGET, MSG)
						DATA[TARGET.userid]['Freeze'] = True
				elif x == 'NOCLIP':
					if DATA[TARGET.userid]['Noclip']:
						unnoclip(TARGET, MSG)
						DATA[TARGET.userid]['Noclip'] = False
					else:
						noclip(TARGET, MSG)
						DATA[TARGET.userid]['Noclip'] = True
				elif x == 'GODMODE':
					if DATA[TARGET.userid]['Godmode']:
						ungod(TARGET, MSG)
						DATA[TARGET.userid]['Godmode'] = False
					else:
						god(TARGET, MSG)
						DATA[TARGET.userid]['Godmode'] = True
				elif x == 'JETPACK':
					if DATA[TARGET.userid]['Jetpack']:
						unjetpack(TARGET, MSG)
						DATA[TARGET.userid]['Jetpack'] = False
					else:
						jetpack(TARGET, MSG)
						DATA[TARGET.userid]['Jetpack'] = True
				elif x == 'BLIND':
					if DATA[TARGET.userid]['Blind']:
						unblind(TARGET, MSG)
						DATA[TARGET.userid]['Blind'] = False
					else:
						blind(TARGET, MSG)
						DATA[TARGET.userid]['Blind'] = True
				elif x == 'RAVE':
					if DATA[TARGET.userid]['Rave']:
						unrave(TARGET, MSG)
						DATA[TARGET.userid]['Rave'] = False
					else:
						rave(TARGET, MSG)
						DATA[TARGET.userid]['Rave'] = True
			else: func.hudhint(ID, func.langPcontrol('TARGET_DEAD'), x)
	if SEND: main_SELECT(ID, CACHE[ID], None, TARGET)

# =============================================================================== #
# === <<<> ONE TIME FUNCTIONS <>>> ============================================== #
# =============================================================================== #
def kick(TARGET, REASON=False, MSG=True):
	if REASON: TARGET.kick(REASON)
	else: TARGET.kick(func.langPcontrol('KICKED_REASON'))
	if MSG: func.tell('#all', func.langPcontrol('TARGET_KICKED', {'target':TARGET.name}), '#greenKICK')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def slap(ID, DMG, POPUP=None, SEND=True, MSG=True):
	x = random.randint(-100, 100)
	y = random.randint(-100, 100)
	z = random.randint(100, 300)
	TARGET = playerlib.getPlayer(CACHE[ID])
	if notDead(TARGET):
		func.sound(TARGET, 'player/damage%s.wav' % random.randint(1,3))
		es.setplayerprop(TARGET, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', es.createvectorstring(x,y,z))
		es.server.insertcmd('damage %s %s' % (TARGET, DMG))
		if MSG: func.tell('#all', func.langPcontrol('TARGET_SLAPED',{'target':TARGET.name}), '#greenSLAP')
	elif MSG: func.hudhint(ID, func.langPcontrol('TARGET_DEAD'), '#greenSLAP')
	if SEND: slap_damage(ID, TARGET, DMG)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def health(ID, AMOUNT, POPUP=None, MSG=True, SEND=True):
	TARGET        = playerlib.getPlayer(CACHE[ID])
	TARGET.health = AMOUNT
	if MSG: func.tell('#all', func.langPcontrol('HEALTH_TOTARGET',{'target':TARGET.name,'amount':AMOUNT}), '#greenHEALTH')
	if SEND:
		CACHE[ID] = 'Health'
		players_list_SELECT(ID, TARGET)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def cash(ID, AMOUNT, POPUP=None, MSG=True, SEND=True):
	TARGET      = playerlib.getPlayer(CACHE[ID])
	TARGET.cash = AMOUNT
	if MSG: func.tell('#all', func.langPcontrol('CASH_TOTARGET',{'target':TARGET.name,'amount':AMOUNT}), '#greenCASH')
	if SEND:
		CACHE[ID] = 'Cash'
		players_list_SELECT(ID, TARGET)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def respawn(TARGET, MSG=True):
	es.setplayerprop(TARGET, 'CCSPlayer.m_iPlayerState', 0)
	es.setplayerprop(TARGET, 'CBasePlayer.m_lifeState', 0)
	es.server.insertcmd('es_xspawnplayer %s' % TARGET)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_RESPAWNED', {'target':TARGET.name}), '#greenRESPAWN')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def slay(TARGET, MSG=True):
	TARGET.kill()
	func.sound(TARGET, 'player\%s.wav' % random.choice(('headshot1','headshot2')))
	if MSG: func.tell('#all', func.langPcontrol('TARGET_SLAYED', {'target':TARGET.name}), '#greenSLAY')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def firework(TARGET, MSG=True):
	var = 'sam_firework_%s' % TARGET
	func.sound(TARGET, 'weapons\physgun_off.wav')
	es.server.insertcmd('usermsg shake %s 85 2' % TARGET)
	t = 0.0
	p = 0
	while t <= 0.9:
		t += 0.1
		p += 35
		gamethread.delayedname(t, var, push, (TARGET, p))
	for x in (1.4,1.5): gamethread.delayedname(x, var, func.sound, (TARGET, 'weapons\c4\c4_beep1.wav'))
	gamethread.delayedname(1.7, var, explosion, (TARGET))
	gamethread.delayedname(1.7, var, func.sound, (TARGET, 'weapons/hegrenade/explode4.wav'))
	if MSG: func.tell('#all', func.langPcontrol('TARGET_ISFIREWORK', {'target':TARGET.name}), '#greenFIREWORK')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def strip(TARGET, MSG=True):
	es.sexec(TARGET, 'drop')
	if MSG: func.tell('#all', func.langPcontrol('TARGET_STRIPED', {'target':TARGET.name}), '#greenWEAPON STRIP')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def freeze(TARGET, MSG=True):
	TARGET.freeze(1)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_FREEZED',{'target':TARGET.name}),'#greenFREEZE')

# ------------------------------------------------------------------------------- #
def unfreeze(TARGET, MSG=True):
	TARGET.freeze(0)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_UNFREEZED',{'target':TARGET.name}),'#greenFREEZE')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def noclip(TARGET, MSG=True):
	TARGET.noclip(1)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_NOCLIP',{'target':TARGET.name}),'#greenNOCLIP')

# ------------------------------------------------------------------------------- #
def unnoclip(TARGET, MSG=True):
	TARGET.noclip(0)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_UNNOCLIP',{'target':TARGET.name}),'#greenNOCLIP')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def god(TARGET, MSG=True):
	TARGET.godmode(1)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_GOD',{'target':TARGET.name}),'#greenGODMODE')

# ------------------------------------------------------------------------------- #
def ungod(TARGET, MSG=True):
	TARGET.godmode(0)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_UNGOD',{'target':TARGET.name}),'#greenGODMODE')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def jetpack(TARGET, MSG=True):
	TARGET.jetpack(1)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_JET',{'target':TARGET.name}),'#greenJETPACK')

# ------------------------------------------------------------------------------- #
def unjetpack(TARGET, MSG=True):
	TARGET.jetpack(0)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_UNJET',{'target':TARGET.name}),'#greenJETPACK')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def blind(TARGET, MSG=True):
	usermsg.fade(TARGET, 2, 1, 70, 0, 0, 0)
	gamethread.delayedname(.01, 'sam_blind_%s' % TARGET.userid, blind, (TARGET,False))
	if MSG: func.tell('#all', func.langPcontrol('TARGET_BLIND',{'target':TARGET.name}),'#greenBLIND')

# ------------------------------------------------------------------------------- #
def unblind(TARGET, MSG=True):
	gamethread.cancelDelayed('sam_blind_%s' % TARGET.userid)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_UNBLIND',{'target':TARGET.name}),'#greenBLIND')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def rave(TARGET, MSG=True):
	usermsg.shake(TARGET, random.randint(20, 30), 1)
	usermsg.fade(TARGET, 2, 1, 100, random.randint(0, 255), random.randint(0, 255), random.randint(0, 255), random.randint(100, 125))
	TARGET.setColor(random.randint(0, 255),random.randint(0, 255),random.randint(0, 255),random.randint(170, 255))
	gamethread.delayedname(.1, 'sam_rave_%s' % TARGET.userid, rave, (TARGET,False))
	if MSG: func.tell('#all', func.langPcontrol('TARGET_RAVE',{'target':TARGET.name}),'#greenRAVE')

# ------------------------------------------------------------------------------- #
def unrave(TARGET, MSG=True):
	gamethread.cancelDelayed('sam_rave_%s' % TARGET.userid)
	TARGET.setColor(255,255,255,255)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_UNRAVE',{'target':TARGET.name}),'#greenRAVE')

# =============================================================================== #
# === <<<> THIRD PARTY FUNCTIONS <>>> =========================================== #
# =============================================================================== #
def notDead(TARGET):
	if int(es.getplayerprop(TARGET, 'CBasePlayer.m_lifeState')) in (512,0): return True
	else: return False

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def explosion(TARGET):
	if notDead(TARGET):
		x,y,z = es.getplayerlocation(TARGET)
		es.server.queuecmd('es_xeffect sparks %s,%s,%s 9999 3 0,0,0' % (x, y, z))
		TARGET.kill()

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def push(TARGET, PUSH):
	if notDead(TARGET): es.setplayerprop(TARGET, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', '0,0,%s' % (PUSH))

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def slap_damage(ID, TARGET, PAGE=False):
	CACHE[ID] = TARGET
	popup = func.easymenu(('PCONTROL_DAMAGE', slap),'PCONTROL_LIST_PLAYERS')
	popup.settitle(func.header(func.langPcontrol('SLAP')))
	popup.addoption(0, func.langPcontrol('NO_DAMAGE'))
	popup.addoption(1, 1)
	num  = 5
	nums = []
	while num <= 100:
		nums.append(num)
		num += 5
	for x in nums: popup.addoption(x, x)
	if PAGE and PAGE in nums: popup.sendPage(ID, func.sendPage(nums.index(PAGE)+2))
	else: popup.send(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def health_amount(ID, TARGET):
	CACHE[ID] = TARGET
	popup = func.easymenu(('PCONTROL_HEALTH', health),'PCONTROL_LIST_PLAYERS')
	popup.settitle(func.header(func.langPcontrol('HEALTH')))
	popup.addoption(250, 250)
	popup.addoption(1, 1)
	num = 5
	while num <= 100:
		popup.addoption(num, num)
		num += 5
	popup.send(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def cash_amount(ID, TARGET):
	CACHE[ID] = TARGET
	popup = func.easymenu(('PCONTROL_CASH', cash),'PCONTROL_MAIN')
	popup.settitle(func.header(func.langPcontrol('CASH')))
	popup.addoption(0, 0)
	num = 800
	while num <= 16000:
		popup.addoption(num, num)
		num += 800
	popup.send(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def add(TARGET):
	TARGET = playerlib.getPlayer(TARGET)
	if not int(TARGET.userid) in DATA: DATA[int(TARGET.userid)] = {}
	for x in TOGGLE: DATA[int(TARGET.userid)][x] = False

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def remove(TARGET):
	TARGET = playerlib.getPlayer(TARGET)
	if int(TARGET.userid) in DATA:
		if DATA[int(TARGET.userid)]['Rave']: unrave(TARGET, False)
		if DATA[int(TARGET.userid)]['Blind']: unblind(TARGET, False)
		for x in TOGGLE: DATA[int(TARGET.userid)][x] = False
	else: add(TARGET)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def cmdFilter(ID, ARGS, FUNC):
	if admins.can(ID, FUNC):
		if ARGS:
			CACHE[ID] = FUNC
			if len(ARGS) == 1:
				target = es.getuserid(ARGS[0])
				if es.exists('userid',target): players_list_SELECT(ID, playerlib.getPlayer(target), None, False)
				else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),func.errortag)
			if len(ARGS) > 1:
				list = [es.getuserid(x) for x in ARGS]
				num  = 0
				for x in list:
					if es.exists('userid',x):
						players_list_SELECT(ID, playerlib.getPlayer(x), None, False, False)
						for i in list:
							if i == x: list.remove(x)
						num+=1
				if num: func.tell('#all', func.langPcontrol('%s_MULTI_TARGETS'%FUNC.replace(' ','_').upper(),{'num':num}),'#green%s'%FUNC.upper())
		else: main_SELECT(ID, FUNC, None, False, False)

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def player_activate(ev): remove(ev['userid'])

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def player_disconnect(ev):
	if int(ev['userid']) in DATA: del DATA[int(ev['userid'])]

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def player_death(ev): remove(ev['userid'])

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def player_spawn(ev): remove(ev['userid'])

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def round_end(ev):
	for x in es.getUseridList(): remove(x)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def round_start(ev):
	for x in es.getUseridList(): remove(x)

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def kickCMD(ID, ARGS): cmdFilter(ID, ARGS, 'Kick')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def respawnCMD(ID, ARGS): cmdFilter(ID, ARGS, 'Respawn')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def slayCMD(ID, ARGS): cmdFilter(ID, ARGS, 'Slay')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def fireworkCMD(ID, ARGS): cmdFilter(ID, ARGS, 'Firework')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def stripCMD(ID, ARGS): cmdFilter(ID, ARGS, 'Weapon Strip')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def blindCMD(ID, ARGS): cmdFilter(ID, ARGS, 'Blind')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def raveCMD(ID, ARGS): cmdFilter(ID, ARGS, 'Rave')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def freezeCMD(ID, ARGS): cmdFilter(ID, ARGS, 'Freeze')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def noclipCMD(ID, ARGS): cmdFilter(ID, ARGS, 'Noclip')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def godmodeCMD(ID, ARGS): cmdFilter(ID, ARGS, 'Godmode')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def jetpackCMD(ID, ARGS): cmdFilter(ID, ARGS, 'Jetpack')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def slapCMD(ID, ARGS):
	if admins.can(ID, 'Slap'):
		if ARGS:
			target = es.getuserid(ARGS[0])
			if len(ARGS) > 1: DMG = ARGS[1]
			else: DMG = 0
			if es.exists('userid',target) and str(DMG).isdigit():
				TARGET = playerlib.getPlayer(target)
				CACHE[ID] = TARGET
				if admins.immunity(ID, TARGET): slap(ID, int(DMG), None, False)
			else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':' '.join(ARGS)}),func.errortag)
		else: main_SELECT(ID, 'Slap', None, False, False)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def healthCMD(ID, ARGS):
	if admins.can(ID, 'Health'):
		if ARGS:
			target = es.getuserid(ARGS[0])
			if len(ARGS) > 1: AMOUNT = ARGS[1]
			else: AMOUNT = 0
			if es.exists('userid',target) and str(AMOUNT).isdigit():
				TARGET = playerlib.getPlayer(target)
				CACHE[ID] = TARGET
				if admins.immunity(ID, TARGET): health(ID, int(AMOUNT), None, True, False)
			else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':' '.join(ARGS)}),func.errortag)
		else: main_SELECT(ID, 'Health', None, False, False)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def cashCMD(ID, ARGS):
	if admins.can(ID, 'Cash'):
		if ARGS:
			target = es.getuserid(ARGS[0])
			if len(ARGS) > 1: AMOUNT = ARGS[1]
			else: AMOUNT = 0
			if es.exists('userid',target) and str(AMOUNT).isdigit():
				if int(AMOUNT) in range(16001):
					TARGET    = playerlib.getPlayer(target)
					CACHE[ID] = TARGET
					if admins.immunity(ID, TARGET): cash(ID, int(AMOUNT), None, True, False)
				else: func.hudhint(ID, 'Amount must be in range of 0 to 16000!', func.errortag)
			else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':' '.join(ARGS)}),func.errortag)
		else: main_SELECT(ID, 'Cash', None, False, False)

# =============================================================================== #